<?php

/**
 * periodo actions.
 *
 * @package    nomina
 * @subpackage periodo
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class periodoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_PERIODO_V',
        'NO_TIPO_PERIODO',
        'MESES'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_TIPO_PERIODO' =>
        array(
            'id_tipo_periodo' => 'NO_PERIODO_V'
        ),
        'MESES' =>
        array(
            'id_meses' => 'NO_PERIODO_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_PERIODO_V' =>
        array(
            'id_periodo' => 'id_periodo',
            'id_anhos' => 'id_anhos',
            'id_meses' => 'id_meses',
            'fecha_ini' => 'fecha_ini',
            'fecha_fin' => 'fecha_fin',
            'id_tipo_periodo' => 'id_tipo_periodo',
            'estado' => 'estado',
            'activo' => 'activo',
            'fecha_cierre' => 'fecha_cierre',
            'fecha_cierre_nov' => 'fecha_cierre_nov',
            'periodo' => 'periodo',
            'max_ded_noley' => 'max_ded_noley',
            'fecha_pago' => 'fecha_pago',
            'num_doc_pago' => 'num_doc_pago',
            'nom_adicional' => 'nom_adicional',
            'definitivo' => 'definitivo',
            'fecha_definitivo' => 'fecha_definitivo',
            'id_mae_ter_definitivo' => 'id_mae_ter_definitivo',
            'num_doc' => 'num_doc',
            'razon_soc' => 'razon_soc',
            'fecha_tesoreria' => 'fecha_tesoreria',
            'observ_tesoreria' => 'observ_tesoreria'
        ),
        'NO_TIPO_PERIODO' =>
        array(
            'codigo' => 'codigo_tipo',
            'descripcion' => 'descripcion_tipo',
            'periodica' => 'periodica',
            'codigo,||, - ,||,descripcion' => 'completo_tipo'
        ),
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_PERIODO_V' => array(
            'id_periodo,a' => array('!=' => array(-1)),
            'id_periodo,b' => array('=' => array('id_periodo_actual')),
//            'id_periodo,c' => array('=' => array('id_periodo_filtro')),
            'id_tipo_periodo' => array('=' => array('id_tipo_periodo')),
            'estado' => array('=' => array('estado')),
            'activo' => array('=' => array('activo')),
            'id_anhos' => array('=' => array('id_anhos')),
            'id_meses' => array('=' => array('id_meses')),
            'definitivo' => array('=' => array('definitivo')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'NO_TIPO_PERIODO' => array(
            'periodica' => array('=' => array('periodica'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'NO_PERIODO_V' => array(
            'id_tipo_periodo,a' => array('=' => array('id_tipo_periodo_a')),
            'id_tipo_periodo,b' => array('=' => array('id_tipo_periodo_b')),
            'id_tipo_periodo,c' => array('=' => array('id_tipo_periodo_c'))
        )
    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'id_anhos DESC', 'id_meses DESC', 'id_tipo_periodo'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_periodo'; //identificador de la tabla
    protected $id_names = array('id_periodo'); //llave primaria
    protected $field_names = array('id_anhos', 'id_meses', 'fecha_ini', 'fecha_fin', 'id_tipo_periodo', 'estado',
        'fecha_cierre', 'fecha_cierre_nov', 'activo', 'max_ded_noley', 'fecha_pago', 'num_doc_pago', 'nom_adicional',
        'definitivo', 'fecha_definitivo', 'id_mae_ter_definitivo', 'fecha_tesoreria', 'observ_tesoreria'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_PERIODO'; //tabla en la cual se aplican los cambios
    protected $has_activo = false; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_periodo'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto

        $id_periodo = $request['id_periodo'];


        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        $sql = <<<EOD
select * 
from no_periodo
where
activo = 1
and id_periodo != $id_periodo
EOD;
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        if (count($records) > 0) {
            //Valida que solo genere error si es por activar/desactivar - 20150313
            if (isset($request['es_activo'])) {
                $errors['mensaje'] = "Ya Existe un Periodo activo.";
                $errors['servicio'] = "periodo";
            }
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $request['id_periodo'] = "";
            $request['fecha_pago'] = "";
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            /*
             * Manejo de errores
             */
            try {

                $id_tipo_periodo = $list_data_post[0]['id_tipo_periodo'];

                /*
                 * Toma en orden descendente de anho y mes, para tomar el ultimo periodo - 20140508
                 */
                $sql = <<<EOD
select id_periodo from no_periodo periodo 
                left join no_tipo_periodo tipo ON tipo.id_tipo_periodo = periodo.id_tipo_periodo
                where periodo.estado = 1 and periodo.activo = 0 and tipo.periodica = 1
                         order by periodo.id_anhos desc, periodo.id_meses desc
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $id_periodo = $records[0]['id_periodo'];


                $id_periodo_nuevo = $list_data_post[0]['id_periodo'];

                //05 - LIQUIDACION DEFINITIVA
                if ($id_tipo_periodo == 5) {

                    $sql = <<<EOD
declare
   
id_periodo_ant1 int;
id_periodo_nuevo1 int;


begin

id_periodo_ant1:= $id_periodo;
id_periodo_nuevo1 := $id_periodo_nuevo;

INSERT INTO NO_ESTADO_FUNC (ID_TIPO_DOC,NUM_DOC,ID_DP,ID_ANHOS,ID_MESES,PERIODO,ACTUAL,ID_CEN_OP,ID_EA)

select ID_TIPO_DOC,NUM_DOC,ID_DP,(select id_anhos from no_periodo where id_periodo = id_periodo_nuevo1) AS ID_ANHOS,(select id_meses from no_periodo where id_periodo = id_periodo_nuevo1) AS ID_MESES
,id_periodo_nuevo1 AS PERIODO,ACTUAL,ID_CEN_OP, ID_EA
from no_estado_retirado_v
where periodo = id_periodo_ant1;
end;
   
EOD;
                } else {

                    $sql = <<<EOD
declare
   
id_periodo_ant1 int;
id_periodo_nuevo1 int;


begin

id_periodo_ant1:= $id_periodo;
id_periodo_nuevo1 := $id_periodo_nuevo;

INSERT INTO NO_ESTADO_FUNC (ID_TIPO_DOC,NUM_DOC,ID_DP,ID_ANHOS,ID_MESES,PERIODO,ACTUAL,ID_CEN_OP,ID_EA)

select ID_TIPO_DOC,NUM_DOC,ID_DP,(select id_anhos from no_periodo where id_periodo = id_periodo_nuevo1) AS ID_ANHOS,(select id_meses from no_periodo where id_periodo = id_periodo_nuevo1) AS ID_MESES
,id_periodo_nuevo1 AS PERIODO,ACTUAL,ID_CEN_OP,ID_EA
from no_estado_func_v
where periodo = id_periodo_ant1;

end;
   
EOD;
                }

                $this->conn->execute($sql);


                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            /*
             * Manejo de errores
             */
            try {

                $id_tipo_periodo = $list_data_post[0]['id_tipo_periodo'];
                $id_periodo_nuevo = $list_data_post[0]['id_periodo'];
                $estado = $list_data_post[0]['estado'];
                $definitivo = $list_data_post[0]['definitivo'];
                $id_mae_ter_definitivo = $request['id_username'];

                /*
                 * Si es de tipo periodo retroactivo actualiza ultimo valor - 20130703
                 * 06 - RETROACTIVO ACTIVOS
                 * 07 - RETROACTIVO RETIRADOS
                 */
                if (($id_tipo_periodo == 6 || $id_tipo_periodo == 7) && $estado == 0) {

                    $logger->info("Si es de tipo periodo retroactivo actualiza ultimo valor.");


                    /**
                     * ACTUALIZAR LA TABLA DE ULTIMO VALOR
                     */
                    //ACTUALIZA LOS VALORES QUE YA EXISTAN          

                    $sql = <<<EOD
select 

TAB.ID_TIPO_DOC,
tab.NUM_DOC,
NVL(
  (select con.ID_CONCEP_NOMINA as ID_CONCEP_NOMINA
  from NO_CONCEP_NOMINA CON    
  where con.ID_CONCEP_AJUSTE = tab.id_concep_nomina)
, tab.id_concep_nomina)   as id_concep_nomina,
TAB.VALOR,
tab.id_liquida_nomina ,

nvl( (
select ult.valor from no_ultimo_valor ult
where ult.num_doc = tab.num_doc and ult.id_concep_nomina = NVL(
  (select con.ID_CONCEP_NOMINA as ID_CONCEP_NOMINA
  from NO_CONCEP_NOMINA CON    
  where con.ID_CONCEP_AJUSTE = tab.id_concep_nomina)
, tab.id_concep_nomina) and  ult.id_tipo_doc = tab.id_tipo_doc  
)  ,0) as valor_ultimo

from(

  select id_tipo_doc,num_doc,id_concep_nomina, sum(nvl(VALOR,0)) as VALOR, max(id_liquida_nomina) as id_liquida_nomina 
  
  from(
                          
    select tab0.id_tipo_doc,tab0.num_doc, tab0.id_concep_nomina, tab0.valor_liquidado AS VALOR, tab0.id_liquida_nomina
    from NO_LIQUIDA_NOMINA TAB0
    join NO_CONCEP_NOMINA TAB1 
    on TAB0.ID_CONCEP_NOMINA = TAB1.ID_CONCEP_NOMINA
    where TAB0.ID_PERIODO = $id_periodo_nuevo
    and tab1.id_tipo_concepto = 1
        and exists (select ultimo.num_doc, ultimo.id_tipo_doc, 
                            
        --ULTIMO.ID_CONCEP_NOMINA 
        NVL(
        (select min(con.ID_CONCEP_NOMINA) as ID_CONCEP_NOMINA
        from NO_CONCEP_NOMINA CON    
        where CON.ID_CONCEP_AJUSTE = ULTIMO.ID_CONCEP_NOMINA)
      , ULTIMO.ID_CONCEP_NOMINA)   as id_concep_nomina
                            
            from NO_ULTIMO_VALOR ULTIMO where ULTIMO.NUM_DOC = TAB0.NUM_DOC 
            
                and ULTIMO.ID_CONCEP_NOMINA = NVL(
        (select min(con.ID_CONCEP_NOMINA) as ID_CONCEP_NOMINA
        from NO_CONCEP_NOMINA CON    
        where CON.ID_CONCEP_AJUSTE = TAB0.ID_CONCEP_NOMINA)
      , TAB0.ID_CONCEP_NOMINA)  
                
                and ultimo.id_tipo_doc = tab0.id_tipo_doc
                
      ) 
                          
  )  
  
  group by
  id_tipo_doc,num_doc,id_concep_nomina  

)tab   

order by
TAB.NUM_DOC,
tab.id_concep_nomina                   
EOD;

                    $records = CN_TABLE::executeSQL($sql);

                    foreach ($records as $liquida) {

                        $valor = $liquida['valor'];
                        $id_liquida_nomina = $liquida['id_liquida_nomina'];
                        $num_doc = $liquida['num_doc'];
                        $id_concep_nomina = $liquida['id_concep_nomina'];
                        $valor_ultimo = $liquida['valor_ultimo'];

                        $logger->info("valor_ultimo - " . $valor_ultimo);


                        $sql = <<<EOD
update no_ultimo_valor mt set mt.valor = mt.valor + $valor,  mt.id_liquida_nomina  = $id_liquida_nomina    
    where mt.num_doc = $num_doc and mt.id_concep_nomina = $id_concep_nomina
EOD;

                        $this->conn->execute($sql);
                    }

                    /**
                     * Se actualizan concepto_func con actual 1 para inactivar conceptos ya no activos - 20150309
                     */
                    //para activos/retirados :: conceptos_AB
                    //VERIFICAR CONCEPTOS ASOCIADOS A LA ASIGNACION BASICA
                    $sql = <<<EOD
select 
nvl((select sum(no_concepto_func.valor) as valor from no_concepto_func where no_concepto_func.num_doc = con.num_doc and no_concepto_func.id_concep_nomina = (select id_concep_basica from no_param_concep where id_param_concep = 1)) ,0) as asignacion_basica,
con.*,
conab.id_concep_ab,
conab.rango_minimo,
conab.rango_maximo,
conab.valor_fijo,
conab.porcentaje as porcentaje_conab,
conab.horas
from no_concepto_func con

join no_concep_ab conab
on conab.id_concep_nomina = con.id_concep_nomina

where conab.estado = 1
and con.estado = 1 and con.actual = 1
and (
    con.fecha_hasta is not null  
    and
    con.fecha_hasta < (select fecha_ini from no_periodo where id_periodo = $id_periodo_nuevo)
) 
EOD;
                    $results = CN_TABLE::executeSQL($sql);

                    if (count($results) > 0) {

                        /*
                         * RECORRO CADA UNO DE LOS CONCEPTOS QUE ESTEN ASOCIADOS
                         */
                        foreach ($results as $conceptos) {

                            $rango_minimo = $conceptos['rango_minimo'];
                            $rango_maximo = $conceptos['rango_maximo'];
                            $id_concep_ab = $conceptos['id_concep_nomina'];
                            $valor_fijo = $conceptos['valor_fijo'];
                            $asignacion_basica = $conceptos['asignacion_basica'];
                            $id_concep_func = $conceptos['id_concep_func'];
                            $id_tipo_doc = $conceptos['id_tipo_doc'];
                            $num_doc = $conceptos['num_doc'];

                            /**
                             * Actualiza estado
                             */
//                            if ($asignacion_basica >= $rango_minimo && $asignacion_basica <= $rango_maximo) {
                            $sql = <<<EOD
UPDATE no_concepto_func set estado = 0
    where id_tipo_doc = $id_tipo_doc and num_doc = $num_doc and id_concep_func = $id_concep_func 
EOD;
                            $this->conn->execute($sql);
//                            }
                        }
                    }
                }
                /*
                 * Si es de tipo periodo prima actualiza ultimo valor - 20130716
                 * 03 - PRIMA DE SERVICIOS
                 * 04 - PRIMA DE NAVIDAD
                 * 
                 */ elseif (($id_tipo_periodo == 3 || $id_tipo_periodo == 4) && $estado == 0) {

                    $logger->info("Si es de tipo periodo retroactivo actualiza ultimo valor prima.");


                    /**
                     * ACTUALIZAR LA TABLA DE ULTIMO VALOR
                     */
                    //INSERTA LOS VALORES NUEVOS POR FUNCIONARIO Y CONCEPTO
                    $sql = <<<EOD
insert into no_ultimo_valor (ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,VALOR,ID_LIQUIDA_NOMINA)
                            
select id_tipo_doc,num_doc,id_concep_nomina, sum(nvl(VALOR,0)) as VALOR, max(id_liquida_nomina) as id_liquida_nomina from(
                        
select tab0.id_tipo_doc,tab0.num_doc, tab0.id_concep_nomina, tab0.valor_liquidado AS VALOR, tab0.id_liquida_nomina
from no_liquida_nomina tab0
    join NO_CONCEP_NOMINA TAB1 
    on TAB0.ID_CONCEP_NOMINA = TAB1.ID_CONCEP_NOMINA
    where tab0.id_periodo = $id_periodo_nuevo
    and tab1.id_tipo_concepto = 1
    and not exists (select ultimo.num_doc, ultimo.id_tipo_doc, ultimo.id_concep_nomina 
        from no_ultimo_valor ultimo where ultimo.num_doc = tab0.num_doc 
            and ultimo.id_concep_nomina = tab0.id_concep_nomina and ultimo.id_tipo_doc = tab0.id_tipo_doc) 
                        
)
group by
id_tipo_doc,num_doc,id_concep_nomina
EOD;

                    $this->conn->execute($sql);


                    //ACTUALIZA LOS VALORES QUE YA EXISTAN  
                    //Si es concepto_nomina ajuste cambiar por concepto_principal
                    $sql = <<<EOD
select 

TAB.ID_TIPO_DOC,
tab.NUM_DOC,
NVL(
  (select con.ID_CONCEP_NOMINA as ID_CONCEP_NOMINA
  from NO_CONCEP_NOMINA CON    
  where con.ID_CONCEP_AJUSTE = tab.id_concep_nomina)
, tab.id_concep_nomina)   as id_concep_nomina,
TAB.VALOR,
tab.id_liquida_nomina ,

nvl( (
select ult.valor from no_ultimo_valor ult
where ult.num_doc = tab.num_doc and ult.id_concep_nomina = NVL(
  (select con.ID_CONCEP_NOMINA as ID_CONCEP_NOMINA
  from NO_CONCEP_NOMINA CON    
  where con.ID_CONCEP_AJUSTE = tab.id_concep_nomina)
, tab.id_concep_nomina) and  ult.id_tipo_doc = tab.id_tipo_doc  
)  ,0) as valor_ultimo

from(

  select id_tipo_doc,num_doc,id_concep_nomina, sum(nvl(VALOR,0)) as VALOR, max(id_liquida_nomina) as id_liquida_nomina 
  
  from(
                          
    select tab0.id_tipo_doc,tab0.num_doc, tab0.id_concep_nomina, tab0.valor_liquidado AS VALOR, tab0.id_liquida_nomina
    from NO_LIQUIDA_NOMINA TAB0
    join NO_CONCEP_NOMINA TAB1 
    on TAB0.ID_CONCEP_NOMINA = TAB1.ID_CONCEP_NOMINA
    where TAB0.ID_PERIODO = $id_periodo_nuevo
    and tab1.id_tipo_concepto = 1
        and exists (select ultimo.num_doc, ultimo.id_tipo_doc, 
                            
        --ULTIMO.ID_CONCEP_NOMINA 
        NVL(
        (select min(con.ID_CONCEP_NOMINA) as ID_CONCEP_NOMINA
        from NO_CONCEP_NOMINA CON    
        where CON.ID_CONCEP_AJUSTE = ULTIMO.ID_CONCEP_NOMINA)
      , ULTIMO.ID_CONCEP_NOMINA)   as id_concep_nomina
                            
            from NO_ULTIMO_VALOR ULTIMO where ULTIMO.NUM_DOC = TAB0.NUM_DOC 
            
                and ULTIMO.ID_CONCEP_NOMINA = NVL(
        (select min(con.ID_CONCEP_NOMINA) as ID_CONCEP_NOMINA
        from NO_CONCEP_NOMINA CON    
        where CON.ID_CONCEP_AJUSTE = TAB0.ID_CONCEP_NOMINA)
      , TAB0.ID_CONCEP_NOMINA)  
                
                and ultimo.id_tipo_doc = tab0.id_tipo_doc
                
      ) 
                          
  )  
  
  group by
  id_tipo_doc,num_doc,id_concep_nomina  

)tab   

order by
TAB.NUM_DOC,
tab.id_concep_nomina                   
EOD;

                    $records = CN_TABLE::executeSQL($sql);

                    foreach ($records as $liquida) {

                        $valor = $liquida['valor'];
                        $id_liquida_nomina = $liquida['id_liquida_nomina'];
                        $num_doc = $liquida['num_doc'];
                        $id_concep_nomina = $liquida['id_concep_nomina'];
                        $valor_ultimo = $liquida['valor_ultimo'];

                        $logger->info("valor_ultimo - " . $valor_ultimo);


                        $sql = <<<EOD
update no_ultimo_valor mt set mt.valor = $valor,  mt.id_liquida_nomina  = $id_liquida_nomina    
    where mt.num_doc = $num_doc and mt.id_concep_nomina = $id_concep_nomina
EOD;

                        $this->conn->execute($sql);
                    }
                }

                //Incidente #13469, si se cierra el periodo se marca como definitivo - 20190726
                if ($estado == 0) {
                    $definitivo = 1;
                }

                /**
                 * Estado definitivo consulta funcionarios - 20170925 
                 */
                if ($definitivo == 1) {

                    $sql = <<<EOD
update NO_PERIODO set definitivo = 1, fecha_definitivo = sysdate, 
    id_mae_ter_definitivo = $id_mae_ter_definitivo    
    where id_periodo = $id_periodo_nuevo and fecha_definitivo is null 
EOD;

                    $this->conn->execute($sql);
                }


                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
